;************************************************************
;2010300	tes spot welder controller						*
;************************************************************
;rev	date		notes									*
;-----------------------------------------------------------*
;00	  	05/18/1999	initial release							*
;************************************************************
scmmdmode	equ		0 
clock		equ		7373
proctype	equ		0
#define		seblock	"2010300s.asm"
#define		eqblock "2010300e.asm"
;************************************************************
 include	"c:\files\mpsrc\_inc\sublist.asm"
;************************************************************



;************************************************************
start		cpuinit
			m25u
			lcdinit
;------------------------------------------------------------
			scmmdsu						;setup command buffering
			scisetup					;initialize serial hardware
			bsf		intcon,gie			;all enabled interrups on
;------------------------------------------------------------
			bcf		option_reg,nrbpu
			movlf	seladdr,0x00
			beep
;************************************************************
			lcdcls
			lcdchar	'P'
			lcdchar	'['
			lcdchar	'0'
			lcdchar	'0'
			lcdchar	']'
			lcdpoke	0x40,'+'
			lcdchar	'['
			lcdchar	'0'
			lcdchar	'0'
			lcdchar	']'
			lcdchar	'-'
			lcdchar	'['
			lcdchar	'0'
			lcdchar	'0'
			lcdchar	']'
			lcdchar	' '
			lcdchar	'R'
			lcdchar	'['
			lcdchar	'0'
			lcdchar	'0'
			lcdchar	']'
;************************************************************








;************************************************************
xloop		lcdpoke	0x0b,'R'
			lcdchar	'E'
			lcdchar	'A'
			lcdchar	'D'
			lcdchar	'Y'
			call	keyscan_			;count change
			btfss	dh,7
			goto	weld?
			call	pdecode
			goto	xloop
;------------------------------------------------------------
weld?		movf	oncount,f			;no weld if zero
			skipnz
			goto	xloop
			btfss	pulse
			goto	xloop
			call	weld
			goto	xloop
;************************************************************



	
;************************************************************
weld		delayms	20					;heavy (60ms) debounce
			btfss	pulse
			goto	weldx
			delayms	20
			btfss	pulse
			goto	weldx
			delayms	20
			btfss	pulse
			goto	weldx
;************************************************************
weldok		lcdpoke	0x0b,'P'
			lcdchar	'U'
			lcdchar	'L'
			lcdchar	'S'
			lcdchar	'E'
			beep
			movff	wrepcount,repcount
;------------------------------------------------------------
weldokl		movff	woncount,oncount	;reload on/off for next cycle
			movff	woffcount,offcount
			btfss	pulse				;if foot up then cancel
			goto	weldx
weldokonl	btfsc	lsync
			goto	weldokonl
			btfss	pulse				;if foot up then cancel
			goto	weldx
			bcf		triac				;pulse 1/2 cycle
			delayms	4					;wait till middle of cycle
			bsf		triac				;to do next pulse
			btfss	pulse
			goto	weldx
			decfsz	woncount,f
			goto	weldokonl
;............................................................
			movf	woffcount,f			;if zero then skip
			skipnz
			goto	weldokrep
			bsf		triac
weldokoffl	btfsc	lsync				
			goto	weldokoffl
			btfss	pulse				;if foot up then cancel
			goto	weldx
			delayms	4					;wait till middle of cycle
			btfss	pulse
			goto	weldx
			decfsz	woffcount,f
			goto	weldokoffl
;............................................................
weldokrep	movf	wrepcount,f			;if zero then end, same as 1
			skipnz
			goto	weldx
			decfsz	wrepcount,f
			goto	weldokl
;************************************************************
weldx		bsf		triac				;turn off triac
			lcdpoke	0x0b,'W'
			lcdchar	'A'
			lcdchar	'I'
			lcdchar	'T'
			lcdchar	'?'
weldxl		delayms	5					;don't exit till switch up
			btfsc	pulse
			goto	weldxl
			delayms	250
			btfsc	pulse
			goto	weldxl
			delayms	250
			btfsc	pulse
			goto	weldxl
weldxl1		call	keyscan_			;wait till kb clear
			btfsc	dh,7
			goto	weldxl1
			return
;************************************************************



			
;************************************************************
pdecode		clrf	ah
			cflge	bl,0,oninc
			cflge	bl,4,ondec
			cflge	bl,1,offinc
			cflge	bl,5,offdec
			cflge	bl,2,repinc
			cflge	bl,6,repdec
nomatch		return
;............................................................
oninc		incf	oncount,f
			movlw	63
			andwf	oncount,f
			goto	pdecodex0
ondec		decf	oncount,f
			movlw	63
			andwf	oncount,f
			goto	pdecodex0
offinc		incf	offcount,f
			movlw	63
			andwf	offcount,f
			goto	pdecodex1
offdec		decf	offcount,f
			movlw	63
			andwf	offcount,f
			goto	pdecodex1
repinc		incf	repcount,f
			movlw	63
			andwf	repcount,f
			goto	pdecodex2
repdec		decf	repcount,f
			movlw	63
			andwf	repcount,f
			goto	pdecodex2
;............................................................
pdecodex0	movff	al,oncount	
			bin2decd 2,0x42
			goto	pdecodexx
pdecodex1	movff	al,offcount	
			bin2decd 2,0x47
			goto	pdecodexx
pdecodex2	movff	al,repcount	
			bin2decd 2,0x4d
;------------------------------------------------------------
pdecodexx	beep
			delayms	10
pdecodexxl	call	keyscan_
			btfsc	dh,7
			goto	pdecodexxl
			return
;************************************************************

















			

;************************************************************
#define		keyport	portb
keymatrix	equ		0					;raw matrix
keycount	equ		dh
bitcount	equ		dl
;************************************************************
keyscan_	movlf	keyport,0x0f		;row bits low
			movlf	fsr,keyport			;row driver
			bsf		fsr,7				
			clrf	keycount
			movlf	indf,0xef			;row 0
			scarry
			movff	al,keyport
			rlf		indf,f				;row 1
			movlw	0x0f
			andwf	al,f
			swapf	keyport,w
			andlw	0xf0
			iorwf	al,f
			rlf		indf,f				;row 2
			nop	
			movff	ah,keyport
			rlf		indf,f				;row 3
			movlw	0x0f
			andwf	ah,f
			swapf	keyport,w
			andlw	0xf0
			iorwf	ah,f
			rlf		indf,f				;all rows off
;------------------------------------------------------------
			comf	al,w				;if all 0xff then no keys down
			skipz						;dh will be zero for no keys
			goto	keyscany_
			comf	ah,w
			skipnz
			return
;------------------------------------------------------------
keyscany_	bsf		keycount,7			;set bit 7 high for any keys flag
			movlf	fsr,bl				;key pointer
			clrf	bitcount
;............................................................
keyscanl0_	rrf		ah,f				;count bits
			rrf		al,f
			skipnc						;low=key down
			goto	keyscanb1_
;............................................................
keyscanb0_	movff	indf,bitcount		;key down
			incf	keycount,f
;////////////////////////////////////////////////////////////
keydecode
			nop
;////////////////////////////////////////////////////////////
			incf	fsr,f
			btfsc	keycount,2			;4 keys max
			return						;limit reached, ignore rest
;............................................................
keyscanb1_	incf	bitcount,f			;16 bits	
			btfss	bitcount,4
			goto	keyscanl0_
			return
;************************************************************










;************************************************************
loop		scmmd
			goto	loop
;************************************************************







			asmender

			
